#include <iostream>
using namespace std;
void f1(long long y,long long a[],long long b[],int n){
    long long sum1=0;
	int j=0;
	while((y-a[j])>=0){
		if(b[j]<=y-a[j]){
			sum1 += b[j];
		}else{
			sum1 += y-a[j]+1;
		}
		j++;
		if(j>=n){
			break;
		}
	}
	cout<<sum1;
}
int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int n,q;
	cin>>n>>q;
    long long a[n];
    long long b[n];
	for(int i=0;i<n;i++){
		cin>>a[i]>>b[i];
	}
    long long x[q];
	for(int i=0;i<q;i++){
		cin>>x[i];
	}
	for(int i=0;i<q;i++){
	 long long y = x[i];
		f1(y,a,b,n);
		cout<<"\n";
	}
    return 0;
}